if init = 0
 init = 1
 voltage = 0
 refreshState = 0
 sportTelemetrySend( 0x17, 0x21, 0x0E50, 0x80 )
 valueread = 0
 modified = 0
end

goto main

incField:
 if voltage < 84
  voltage += 1
 end
return

decField:
 if voltage > 50
  voltage -= 1
 end
return

runpage:
drawclear()
drawtext( 0, 0, "SXR", INVERS )
drawtext( 0, 16, "Sbec Voltage", INVERS )
drawnumber( 127, 16, voltage, PREC1 | INVERS )
drawnumber( 127, 24, primId, 0 )
drawnumber( 127, 32, dataId, 0 )
drawnumber( 127, 40, fieldId, 0 )
drawnumber( 127, 48, value, 0 )
drawnumber( 63, 56, scount, 0 )
drawnumber( 127, 56, rcount, 0 )
if (Event = EVT_MENU_BREAK) | (Event = EVT_BTN_BREAK)
 if valueread
  if edit
	 edit = 0
	 modified = 1
	else
	 edit = 1
	end
 end
else
 if edit
  if Event = EVT_RIGHT_FIRST then gosub incField
  if Event = EVT_LEFT_FIRST then gosub decField
rem for encoder use:
  if Event = EVT_UP_FIRST then gosub decField
  if Event = EVT_DOWN_FIRST then gosub incField
 end
end
return

refresh:
 if refreshState = 0
  result = sportTelemetrySend( 0x17, 0x30, 0x0E50, 0x80 )
	sresult = result
  if result
   refreshState = 1
   telemetryPopTimeout = gettime() + 80
  end
 elseif refreshState = 1
	result = sportTelemetryReceive( physicalId, primId, dataId, value )
	cresult = result
	rcount += 1
	scount += 1
  if result > 0
   if primId = 0x32
    if dataId = 0x0E50
     result = 2
     fieldId = value & 0x00FF
		 refreshState = 2
		 if fieldId = 0x80
      value /= 256
      voltage = value
			valueread = 1
     end
		end
	 end
	end
  if result # 2
   if gettime() > telemetryPopTimeout
    refreshState = 0
		retries += 1
		if retries > 3
		 retries = 0
    end
   end
  end
 end
 if refreshState = 2
  if modified
   sportTelemetrySend( 0x17, 0x31, 0x0E50, 0x80 + voltage*256)
	 modified = 0
	end
 end
return


main:
 if Event = EVT_EXIT_BREAK then goto done
 if Event = 0x81 then goto done
 gosub refresh
 gosub runpage

stop
done:
 sportTelemetrySend( 0x17, 0x20, 0x0E50, 0x80 )
finish

